<!--
  -    Copyright 2014-2023 IHE International
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<ui:composition xmlns:f="http://java.sun.com/jsf/core" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:c="http://java.sun.com/jsp/jstl/core"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:rich="http://richfaces.org/rich"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:g="http://www.ihe.net/gazelle"
                xmlns:h="http://java.sun.com/jsf/html" xmlns="http://www.w3.org/1999/xhtml">
    <div class="row">
        <div class="col-md-6">
            <ui:decorate template="/layout/panels/_panel_title_id.xhtml">
                <ui:param name="panel_id" value="systemDetails"/>
                <ui:define name="panel_title">#{messages['net.ihe.gazelle.questionnaire.SystemDetails']}</ui:define>
                <div class="form-horizontal">
                    <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml">
                        <ui:param name="id" value="keywordDisplay"/>
                        <ui:param name="styleClass" value="form-group-sm"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.questionnaire.SystemsKeyword']}</ui:define>
                        <p class="form-control-static">
                            <h:outputText id="keywordDisplay" value="#{managedBean.questionnaire.system}"/>
                        </p>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml">
                        <ui:param name="id" value="orgDisplay"/>
                        <ui:param name="styleClass" value="form-group-sm"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.questionnaire.SystemsOrganization']}
                        </ui:define>
                        <p class="form-control-static">
                            <h:outputText id="orgDisplay" value="#{managedBean.questionnaire.company}"/>
                        </p>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml">
                        <ui:param name="id" value="sessionDisplay"/>
                        <ui:param name="styleClass" value="form-group-sm"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.questionnaire.TestingSession']}</ui:define>
                        <p class="form-control-static">
                            <h:outputText id="sessionDisplay"
                                          value="#{managedBean.questionnaire.testingSession.description}"/>
                        </p>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml"
                                rendered="#{mode.equals('view') || mode.equals('proofread')}">
                        <ui:param name="id" value="systemTypeDisplay"/>
                        <ui:param name="styleClass" value="form-group-sm"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.questionnaire.SystemType']}</ui:define>
                        <p class="form-control-static">
                            <h:outputText id="systemTypeDisplay" value="#{managedBean.questionnaire.systemType.value}"/>
                        </p>
                    </s:decorate>
                    <h:form id="editSystemTypeForm">
                        <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml"
                                    rendered="#{mode.equals('edit')}">
                            <ui:param name="id" value="systemTypeInput"/>
                            <ui:param name="styleClass" value="form-group-sm"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.questionnaire.SystemType']}</ui:define>
                            <h:selectOneMenu value="#{managedBean.questionnaire.systemType}" id="systemTypeInput"
                                             styleClass="form-control">
                                <f:selectItems value="#{managedBean.getSystemTypes()}"/>
                                <a4j:ajax event="change" for="systemTypeInput" render=":globalDiv"
                                          listener="#{managedBean.save()}" execute="@form"/>
                            </h:selectOneMenu>
                        </s:decorate>
                    </h:form>
                </div>
            </ui:decorate>
        </div>
        <div class="col-md-6">
            <s:decorate template="/layout/panels/_panel_title_id.xhtml">
                <ui:param name="panel_id" value="questDetails"/>
                <ui:define name="panel_title">#{messages['net.ihe.gazelle.questionnaire.QuestionnaireDetails']}
                </ui:define>
                <div class="form-horizontal">
                    <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml"
                                rendered="#{mode.equals('view')}">
                        <ui:param name="id" value="statusDisplay"/>
                        <ui:param name="styleClass" value="form-group-sm"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.questionnaire.QuestionnairesStatus']}
                        </ui:define>
                        <p class="form-control-static">
                            <h:outputText id="statusDisplay" value="#{managedBean.questionnaire.status.value}"/>
                            <h:outputLink value="#{managedBean.linkToProofreadMode()}"
                                          rendered="#{s:hasRole('monitor_role')}"
                                          title="#{messages['net.ihe.gazelle.questionnaire.SwitchToProofreadMode']}">
                            <span class="gzl-icon-stack">
                                <i class="fa fa-file-o gzl-icon-stack-1x"></i>
                                <i class="gzl-icon-checked gzl-icon-stack-1x gzl-icon-stack-right"></i>
                            </span>
                            </h:outputLink>
                        </p>
                    </s:decorate>
                    <h:form id="editQuestionnaireStatusForm">
                        <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml"
                                    rendered="#{not mode.equals('view')}">
                            <ui:param name="id" value="statusInput"/>
                            <ui:param name="styleClass" value="form-group-sm"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.questionnaire.QuestionnairesStatus']}
                            </ui:define>
                            <h:selectOneMenu id="statusInput" value="#{managedBean.questionnaire.status}"
                                             styleClass="form-control">
                                <f:selectItems value="#{managedBean.getQuestionnaireStatuses()}"/>
                                <a4j:ajax event="change" for="statusInput" render=":questDetails"
                                          listener="#{managedBean.save()}" execute="@form"/>
                            </h:selectOneMenu>
                        </s:decorate>
                    </h:form>

                    <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml">
                        <ui:param name="id" value="linkDisplay"/>
                        <ui:param name="styleClass" value="form-group-sm"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.questionnaire.PermanentLink']}</ui:define>
                        <p class="form-control-static">
                            <h:outputLink id="linkDisplay" target="_blank"
                                          value="#{managedBean.getPermanentLink(managedBean.questionnaire.id)}">
                                #{managedBean.getPermanentLink(managedBean.questionnaire.id)}
                            </h:outputLink>
                        </p>
                    </s:decorate>

                    <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml">
                        <ui:param name="id" value="creatorDisplay"/>
                        <ui:param name="styleClass" value="form-group-sm"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.questionnaire.Creator']}</ui:define>
                        <p class="form-control-static">
                            <h:outputText id="creatorDisplay"
                                          value="#{managedBean.getUserName(managedBean.questionnaire.getUsernameWithKey())}"/>
                        </p>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml"
                                rendered="#{not empty managedBean.questionnaire.reviewer}">
                        <ui:param name="id" value="reviewerDisplay"/>
                        <ui:param name="styleClass" value="form-group-sm"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.questionnaire.Reviewer']}</ui:define>
                        <p class="form-control-static">
                            <h:outputText id="reviewerDisplay"
                                          value="#{managedBean.getUserName(managedBean.questionnaire.getReviewerWithKey())}"/>
                        </p>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml">
                        <ui:param name="id" value="modifierDisplay"/>
                        <ui:param name="styleClass" value="form-group-sm"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.questionnaire.LastModifier']}</ui:define>
                        <p class="form-control-static">
                            <h:outputText id="modifierDisplay"
                                          value="#{managedBean.getUserName(managedBean.questionnaire.getLastModifierWithKey())}"/>
                        </p>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml">
                        <ui:param name="id" value="modifiedOnDisplay"/>
                        <ui:param name="styleClass" value="form-group-sm"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.questionnaire.LastModifiedOn']}</ui:define>
                        <p class="form-control-static">
                            <g:date id="modifiedOnDisplay" value="#{managedBean.questionnaire.lastModifiedDate}"/>
                        </p>
                    </s:decorate>
                </div>
            </s:decorate>
        </div>
    </div>
</ui:composition>
